#!/usr/bin/env python
#!coding: utf-8
import os
import sys
import commands
def kivetelszotar(javitottfajl):
    eredetiszo=[]
    helyettesitoszo=[]
    try:    
        f=open(os.getenv('HOME')+'/hangoskonyv.kiv', "r")
        sor=f.read()
    except:
        return()
    szavak=sor.split("\n")
    for i in range(0,len(szavak)-1, 2):
        eredetiszo=eredetiszo+[szavak[i]]
        helyettesitoszo=helyettesitoszo+[szavak[i+1]]
        if szavak[i].islower():
            eredetiszo=eredetiszo+[str(szavak[i].capitalize())]
            helyettesitoszo=helyettesitoszo+[str(szavak[i+1].capitalize())]
    g=open(javitottfajl,"rw")
    sor=g.read()
    g.close()
    i=0
    for szo in eredetiszo:
        sor=sor.replace(szo,helyettesitoszo[eredetiszo.index(szo)])
    g=open(javitottfajl,"w")
    g.write(sor)
    if legyeneszunet=="1":
        g.write("\n\n\n\nv")
    g.close

def filenevbekerese():
    parancs="zenity --file-selection --file-filter=\"Minden támogatott formátum *.txt *.doc *.pdf *.odt *.html\" --file-filter=\"szövegfájlok *.txt\" \
--file-filter=\"Word dokumentumok *.doc\" --file-filter=\"Pdf fájlok *.pdf\" \
--file-filter=\"Odt fájlok *.odt\" --file-filter=\"html fájlok *.html *.htm\""
    adat=commands.getoutput(parancs)
    return adat
def vagasidobeallitasa():
    # Translators: this string mean cutting dialog title.
    #
    cim=_("Setting the cutting time")
    cim=cim.encode('utf-8')
    # Translators: This string present the cutting time setting dialog text
    #
    uzenet=_("Please setting the cutting time. The value is meaning minute, the stepping rate is 15 steps:")
    uzenet=uzenet.encode('utf-8')
    parancs='zenity --scale --title="'+cim+'" --text="'+uzenet+'" --min-value=15 --max-value=600 --value=60 --step=15'
    vagasido=commands.getoutput(parancs)
    if vagasido=="":
        vagasido=60
    return vagasido

def sebessegbeallitasa():
    # Translators: this string means the speech rate setting dialog title
    #
    cim=_("Setting the speech rate")
    cim=cim.encode('utf-8')
    # Translators: This string meaning the setting speech rate dialog message
    #
    uzenet=_("Please set the speech rate. The value meaning words /minute. The default value is 170, but the 230 value will be resulting good read speed. The maximum speech rate value is 390:")
    uzenet=uzenet.encode('utf-8')
    parancs='zenity --scale --title="'+cim+'" --text="'+uzenet+'" --min-value=80 --max-value=390 --value=230 --step=10'
    sebesseg=commands.getoutput(parancs)
    if sebesseg=="":
        sebesseg=230
    return sebesseg

def hangmagassagbeallitasa():
    # Translators: this string meaning setting speech pitch dialog title
    #
    cim=_("Setting speech pitch")
    cim=cim.encode('utf-8')
    # Translators: this string meaning setting speech pitch dialog text
    #
    uzenet=_("Please set the speech pitch. The default speech pitch is 50, but the 30 speech pitch value resulting good reading speech pitch. The maximum speech pitch value is 90:")
    uzenet=uzenet.encode('utf-8')
    hangmagassag=commands.getoutput('zenity --scale --title="'+cim+'" --text="'+uzenet+'" --min-value=0 --max-value=90 --value=30 --step=5')
    if hangmagassag=="":
        hangmagassag=230
    return hangmagassag

def bitratabeallitasa():
    # Translators: this string meaning bitrate dialog setting title
    #
    cim=_("Set output mp3 files bitrate")
    cim=cim.encode('utf-8')
    # Translators: This string meaning output mp3 bitrate setting dialog text
    #
    uzenet=_("Please set the converted output mp3 files bitrate. Possible choose value 32 to 128:")
    uzenet=uzenet.encode('utf-8')
    bitrate=commands.getoutput('zenity --scale --title="'+cim+'" --text="'+uzenet+'" --min-value=32 --max-value=128 --step=32 --value=32')
    if bitrate=="":
        bitrate=32
    return bitrate

def legyeneszunet():

    uzenet=_("Would like pauses between the sentences?")
    uzenet=uzenet.encode('utf-8')
    oklabeltext=_("_Yes")
    cancellabeltext=_("_No")
    oklabeltext=oklabeltext.encode('utf-8')
    cancellabeltext=cancellabeltext.encode('utf-8')
    legyeneszunet=commands.getoutput('zenity --question --text="'+uzenet+'" --ok-label="'+oklabeltext+'" --cancel-label="'+cancellabeltext+'" ;echo $?')
    return legyeneszunet

def pdftotxt():
    commands.getoutput('pdftotext "'+TXT_FILE+'" '+TMP_FILE)
    kivetelszotar(TMP_FILE)

def doctotxt():
    commands.getoutput('antiword "'+TXT_FILE+'" >'+TMP_FILE)
    kivetelszotar(TMP_FILE)

def odt2txt():
    commands.getoutput('odt2txt --width=80 "'+TXT_FILE+'" > "'+TMP_FILE+'"')
    kivetelszotar(TMP_FILE)

def vagas():
    wavfileneve='/tmp/'+basename[0]+'.wav'
    # Translators: This string mean temporary speech audio files generation dialog title
    #
    cim=_("Generating temporary audio files")
    cim=cim.encode('utf-8')
    uzenet=_("Generating temporary audio files. Please be patient, this task possible require longer time.")
    uzenet=uzenet.encode('utf-8')
    if legyeneszunet=="0":
        commands.getoutput('espeak -v hu -m -p '+str(hangmagassag)+' -s '+str(sebesseg)+' -f "'+TMP_FILE+'" -w "'+wavfileneve+'" --split='+str(vagasido)+'|zenity --progress --title="'+cim+'" --text="'+uzenet+'" --auto-close --auto-kill')
    else:
        commands.getoutput('espeak -v hu -m -z -p '+str(hangmagassag)+' -s '+str(sebesseg)+' -f "'+TMP_FILE+'" -w "'+wavfileneve+'" --split='+str(vagasido)+'|zenity --progress --title="'+cim+'" --text="'+uzenet+'" --auto-close --auto-kill')
    # Translators: This string meaning main audio book folder name with the users home directory. Feel free to translate this folder name
    #
    audiobookdir=_("audio books")
    audiobookdir=audiobookdir.encode('UTF-8')
    commands.getoutput('mkdir -p "'+os.environ['HOME']+'/'+audiobookdir+'"')
    utvonal=str(os.environ['HOME']+'/'+audiobookdir+'/'+basename[0])
    commands.getoutput('mkdir -p "'+utvonal+'"')
    utvonal=utvonal+'/'
    wavok=commands.getoutput("ls /tmp/*.wav")
    wavok=wavok.split("\n")
    m3u=utvonal+basename[0]+'.m3u'
    f=open(m3u,'w')
    for wav in wavok:
        mp3nev=os.path.splitext(os.path.basename(wav))
        mp3neve=mp3nev[0]+".mp3"
        # Translators: This message meaning converting mp3 files information message string
        #
        uzenet=_("Generating %s...") % mp3neve.decode('utf-8')
        uzenet=uzenet.encode('utf-8')
        parancs=('gogo -nopsy -silent -b '+str(bitrate)+' "'+wav+'" "'+utvonal+mp3neve+'" |zenity --progress --text="'+uzenet+'" --auto-close --auto-kill')
        os.system(parancs)
        f.write(mp3neve+'\n')
        commands.getoutput('rm "'+wav+'"')
    f.close()
    mp3szam=commands.getoutput('ls "'+utvonal+basename[0]+'"*.mp3|wc -l')
    cim=_("Audio Book Converter")
    cim=cim.encode('utf-8')
    audiobookpath=audiobookdir+'/'+basename[0]
    if mp3szam!='1':
        uzenet=_("The audio book conversation is finished. The converted book splitted with %s mp3 files. You found the converted audio book your home directory in the %s folder. M3u file is automaticaly generated.") % (str(mp3szam).decode('utf-8'), audiobookpath.decode('utf-8'))
    else:
        uzenet=_("The audio book conversation is finished. The converted book splitted with %s mp3 file. You found the converted audio book your home directory in the %s folder. M3u file is automaticaly generated.") % (str(mp3szam).decode('utf-8'), audiobookpath.decode('utf-8'))
    commands.getoutput('zenity --info --title="'+cim+'" --text="'+uzenet.encode('utf-8')+'"')
    commands.getoutput("rm "+TMP_FILE)

def konvertalasegyben():
    # Translators: This string meaning main audio book folder name with the users home directory. Feel free to translate this folder name
    #
    audiobookdir=_("audio books")
    audiobookdir=audiobookdir.encode('UTF-8')
    commands.getoutput('mkdir -p "'+os.environ['HOME']+'/'+audiobookdir+'"')
    utvonal=str(os.environ['HOME']+'/'+audiobookdir+'/'+basename[0])
    commands.getoutput('mkdir -p "'+utvonal+'"')
    utvonal=utvonal+'/'
    # Translators: if the user converting a book with one audio file, this string meaning the conversation progress dialog message
    #
    uzenet=_("Converting %s file...") % (basename[0]+basename[1])
    uzenet=uzenet.encode('utf-8')
    if legyeneszunet=='0':
        commands.getoutput('espeak -v hu -m -p '+str(hangmagassag)+' -s '+str(sebesseg)+' -f "'+TMP_FILE+'" -w /dev/stdout|gogo -nopsy -silent -b '+str(bitrate)+' /dev/stdin "'+utvonal+basename[0]+'.mp3" |zenity --progress --text="'+uzenet+'" --auto-close --auto-kill')
    else:
        commands.getoutput('espeak -v hu -m -z -p '+str(hangmagassag)+' -s '+str(sebesseg)+' -f "'+TMP_FILE+'" -w /dev/stdout|gogo -nopsy -silent -b '+str(bitrate)+' /dev/stdin "'+utvonal+basename[0]+'.mp3" |zenity --progress --text="'+uzenet+'" --auto-close --auto-kill')
    # Translators: This string meaning main audio book converter title
    #
    cim=_("Audio Book Converter")
    cim=cim.encode('utf-8')
    # Translators: when the conversation is finished, this string meaning the information message dialog text. %s meaning the audio book folder path.
    #
    uzenet=_("The conversation is finished. You found the converted audio book your home directory in the %s folder.") % (audiobookdir.decode('utf-8')+'/'+basename[0].decode('utf-8'))
    uzenet=uzenet.encode('utf-8')
    commands.getoutput('zenity --info --title="'+cim+'" --text="'+uzenet+'"')
    commands.getoutput('rm "'+TMP_FILE)

import locale
import gettext

APP="hangoskonyv"
DIR="/usr/share/locale"

locale.setlocale(locale.LC_ALL, "")
gettext.bindtextdomain(APP, DIR)
gettext.textdomain(APP)
gettext.install(APP, DIR, unicode=1)

if len(sys.argv)!=1:
    filenevek=[]
    for i in range(1,len(sys.argv)):
        filenevek=filenevek+[sys.argv[i]]
else:
    TXT_FILE=filenevbekerese()
    filenevek=[]
    filenevek=filenevek+[TXT_FILE]
    if TXT_FILE=="":
        sys.exit()
TMP_FILE="/tmp/espeak.txt"
uzenet=_("Would like split the converted audio book with smaller files?")
oklabel=_("_Yes")
cancellabel=_("_No")
kellvagas=commands.getoutput('zenity  --question --text="'+uzenet.encode('utf-8')+'" --ok-label="'+oklabel.encode('utf-8')+'" --cancel-label="'+cancellabel.encode('utf-8')+'"; echo $?')
if kellvagas=="0":
    vagasido=vagasidobeallitasa()
sebesseg=sebessegbeallitasa()
hangmagassag=hangmagassagbeallitasa()
bitrate=bitratabeallitasa()
legyeneszunet=legyeneszunet()
for TXT_FILE in filenevek:
    basename=os.path.splitext(os.path.basename(TXT_FILE))
    if basename[1]==".doc":
        doctotxt()
    if basename[1]==".pdf":
        pdftotxt()
    if basename[1]==".odt":
        odt2txt()
    if (basename[1]==".html") or (basename[1]==".htm"):
        f=open(TXT_FILE,"r")
        szoveg=f.read()
        f.close()
        f=open("/tmp/espeak.txt","w")
        f.write(szoveg)
        f.close()
        TMP_FILE='/tmp/espeak.txt'
        kivetelszotar(TMP_FILE)
    if basename[1]==".txt":
        f=open(TXT_FILE,"r")
        szoveg=f.read()
        f.close()
        f=open("/tmp/espeak.txt","w")
        f.write(szoveg)
        f.close()
        TMP_FILE='/tmp/espeak.txt'
        kivetelszotar(TMP_FILE)
    if kellvagas=="0":
        vagas()
    else:
        konvertalasegyben()
